Description

ActiveRecord uses db/schema.rb when ActiveRecord::Base.schema_format is :ruby and db/structure.sql when

ActiveRecord::Base.schema_format is :sql.

:sql is needed to use SQL that isn't supported by Active Record's migration API.

For example, WITH of PostgreSQL's CREATE INDEX isn't supported.

I'm using SQL that isn't supported by Active Record's migration API in https://github.com/clear-code/redmine_full_text_search .

db:migrate in Rails supports :ruby and :sql.

https://github.com/rails/rails/blob/master/activerecord/lib/active_record/railties/databases.rake#L91-L93

So it's better that redmine:plugins:migrate also supports :ruby and :sql.

Related issues:

Related to Redmine - Defect #38199: Fix deprecation warning for db:structure:... Closed

Associated revisions

Revision 18212 - 2019-06-01 11:34 - Go MAEDA

Add support for :sql ActiveRecord::Base.schema_format in redmine:plugins:migrate (#31485).

Patch by Kouhei Sutou.

History

#1 - 2019-06-01 04:50 - Go MAEDA

- Target version set to 4.1.0

#2 - 2019-06-01 11:03 - Go MAEDA

Kouhei Sutou wrote:

db:migrate in Rails supports :ruby and :sql.

https://github.com/rails/rails/blob/master/activerecord/lib/active_record/railties/databases.rake#L91-L93

 It was added by this commit for Rails 3.2.0.

https://github.com/rails/rails/commit/15fb4302b6ff16e641b6279a3530eb8ed97f2899

#3 - 2019-06-01 11:34 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch. Thank you.

#4 - 2023-01-20 03:36 - Go MAEDA

- Related to Defect #38199: Fix deprecation warning for db:structure:dump in db:migrate when using sql schema format added

Files

add-support-for-schema-format-sql.diff 538 Bytes 2019-05-31 Kouhei Sutou
